Kea: isc::eval::EvalParser::value_type Class Reference

| Kea 3.2.0-git

isc::eval::EvalParser::value_type Class Reference

A buffer to store and retrieve objects. More...

`#include <parser.h>`

## Public Types
typedef value_type | self_type
| Type of *this.

## Public Member Functions
| value_type () YY_NOEXCEPT
| Empty construction.
template<typename T>
| value_type (YY_RVREF(T) t)
| Construct and fill.
| ~value_type () YY_NOEXCEPT
| Destruction, allowed only if empty.
template<typename T>
const T & | as () const YY_NOEXCEPT
| Const accessor to a built T (for printer).
template<typename T>
T & | as () YY_NOEXCEPT
| Accessor to a built T.
template<typename T>
T & | build ()
| Instantiate an empty T in here.
template<typename T>
T & | build (const T &t)
| Instantiate a T in here from t.
template<typename T>
void | copy (const self_type &that)
| Copy the content of that to this.
template<typename T>
void | destroy ()
| Destroy the stored T.
template<typename T>
T & | emplace ()
| Instantiate an empty T in here.
template<typename T>
T & | emplace (const T &t)
| Instantiate a T in here from t.
template<typename T>
void | move (self_type &that)
| Move the content of that to this.
template<typename T>
void | swap (self_type &that) YY_NOEXCEPT
| Swap the content with that, of same type.

## Detailed Description

A buffer to store and retrieve objects.

Sort of a variant, but does not keep track of the nature of the stored data, since that knowledge is available via the current parser state.

Definition at line 228 of file parser.h.

## Member Typedef Documentation

## ◆ self_type

typedef value_type isc::eval::EvalParser::value_type::self_type

Type of *this.

Definition at line 232 of file parser.h.

## Constructor & Destructor Documentation

## ◆ value_type() [1/2]

isc::eval::EvalParser::value_type::value_type | ( |  | ) |
| inline

Empty construction.

Definition at line 235 of file parser.h.

References YY_NOEXCEPT, and yyraw_.

## ◆ value_type() [2/2]

template<typename T>

isc::eval::EvalParser::value_type::value_type | ( | YY_RVREF(T) | t | ) |
| inline

Construct and fill.

Definition at line 242 of file parser.h.

References EVAL_ASSERT, YY_MOVE, and YY_RVREF.

## ◆ ~value_type()

isc::eval::EvalParser::value_type::~value_type | ( |  | ) |
| inline

Destruction, allowed only if empty.

Definition at line 257 of file parser.h.

References EVAL_ASSERT, and YY_NOEXCEPT.

## Member Function Documentation

## ◆ as() [1/2]

template<typename T>

const T & isc::eval::EvalParser::value_type::as | ( |  | ) | const
| inline

Const accessor to a built T (for printer).

Definition at line 329 of file parser.h.

References EVAL_ASSERT, and YY_NOEXCEPT.

## ◆ as() [2/2]

template<typename T>

T & isc::eval::EvalParser::value_type::as | ( |  | ) |
| inline

Accessor to a built T.

Definition at line 318 of file parser.h.

References EVAL_ASSERT, and YY_NOEXCEPT.

Referenced by copy(), destroy(), move(), isc::eval::EvalParser::parse(), and swap().

## ◆ build() [1/2]

template<typename T>

T & isc::eval::EvalParser::value_type::build | ( |  | ) |
| inline

Instantiate an empty T in here.

Obsolete, use emplace.

Definition at line 301 of file parser.h.

References emplace().

Here is the call graph for this function:

## ◆ build() [2/2]

template<typename T>

T & isc::eval::EvalParser::value_type::build | ( | const T & | t | ) |
| inline

Instantiate a T in here from t.

Obsolete, use emplace.

Definition at line 310 of file parser.h.

References emplace().

Here is the call graph for this function:

## ◆ copy()

template<typename T>

void isc::eval::EvalParser::value_type::copy | ( | const self_type & | that | ) |
| inline

Copy the content of that to this.

Definition at line 384 of file parser.h.

References as(), and emplace().

Here is the call graph for this function:

## ◆ destroy()

template<typename T>

void isc::eval::EvalParser::value_type::destroy | ( |  | ) |
| inline

Destroy the stored T.

Definition at line 392 of file parser.h.

References as().

Referenced by move().

Here is the call graph for this function:

## ◆ emplace() [1/2]

template<typename T>

T & isc::eval::EvalParser::value_type::emplace | ( |  | ) |
| inline

Instantiate an empty T in here.

Definition at line 277 of file parser.h.

References EVAL_ASSERT.

Referenced by build(), build(), copy(), move(), and isc::eval::EvalParser::parse().

## ◆ emplace() [2/2]

template<typename T>

T & isc::eval::EvalParser::value_type::emplace | ( | const T & | t | ) |
| inline

Instantiate a T in here from t.

Definition at line 288 of file parser.h.

References EVAL_ASSERT.

## ◆ move()

template<typename T>

void isc::eval::EvalParser::value_type::move | ( | self_type & | that | ) |
| inline

Move the content of that to this.

Destroys that.

Definition at line 359 of file parser.h.

References as(), destroy(), emplace(), and swap().

Here is the call graph for this function:

## ◆ swap()

template<typename T>

void isc::eval::EvalParser::value_type::swap | ( | self_type & | that | ) |
| inline

Swap the content with that, of same type.

Both variants must be built beforehand, because swapping the actual data requires reading it (with as()), and this is not possible on unconstructed variants: it would require some dynamic testing, which should not be the variant's responsibility. Swapping between built and (possibly) non-built is done with self_type::move ().

Definition at line 347 of file parser.h.

References as(), EVAL_ASSERT, and YY_NOEXCEPT.

Referenced by move().

Here is the call graph for this function:

## Member Data Documentation

## ◆ yyalign_me_

long double isc::eval::EvalParser::value_type::yyalign_me_

Strongest alignment constraints.

Definition at line 468 of file parser.h.

## ◆ yyraw_

char isc::eval::EvalParser::value_type::yyraw_[size]

A buffer large enough to store any of the semantic values.

Definition at line 470 of file parser.h.

Referenced by value_type().

The documentation for this class was generated from the following file:

- parser.h